package com.ejie.ab39a.control;

import com.ejie.ab39a.service.ElementosPeService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.ElementosPe;

/**
 * ElementosPeController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/elementospe")

public class ElementosPeController {

	private static final Logger logger = LoggerFactory.getLogger(ElementosPeController.class);

	@Autowired
	private ElementosPeService elementosPeService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param codelementope
	 *            Integer codigo elementope
	 * @return ElementosPe Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{codelementope}", method = RequestMethod.GET)
	public @ResponseBody ElementosPe get(@PathVariable Integer codelementope) {
		ElementosPe elementosPe = new ElementosPe();
		elementosPe.setCodelementope(codelementope);
		elementosPe = this.elementosPeService.find(elementosPe);
		ElementosPeController.logger.info("[GET - findBy_PK] : Obtener ElementosPe por PK");
		return elementosPe;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterElementosPe
	 *            ElementosPe Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<ElementosPe> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<ElementosPe> getAll(@ModelAttribute ElementosPe filterElementosPe) {
		ElementosPeController.logger.info("[GET - find_ALL] : Obtener ElementosPe por filtro");
		return this.elementosPeService.findAll(filterElementosPe, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param elementosPe
	 *            ElementosPe Bean que contiene la informacion a modificar.
	 * @return ElementosPe Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody ElementosPe edit(@RequestBody ElementosPe elementosPe) {
		ElementosPe elementosPeAux = this.elementosPeService.update(elementosPe);
		ElementosPeController.logger.info("[PUT] : ElementosPe actualizado correctamente");
		return elementosPeAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param elementosPe
	 *            ElementosPe Bean que contiene la informacion con la que se va
	 *            a crear el nuevo registro.
	 * @return ElementosPe Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody ElementosPe add(@RequestBody ElementosPe elementosPe) {
		ElementosPe elementosPeAux = this.elementosPeService.add(elementosPe);
		ElementosPeController.logger.info("[POST] : ElementosPe insertado correctamente");
		return elementosPeAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param codelementope
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return ElementosPe Bean eliminado.
	 */
	@RequestMapping(value = "/{codelementope}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ElementosPe remove(@PathVariable Integer codelementope) {
		ElementosPe elementosPe = new ElementosPe();
		elementosPe.setCodelementope(codelementope);
		this.elementosPeService.remove(elementosPe);
		ElementosPeController.logger.info("[DELETE] : ElementosPe borrado correctamente");
		return elementosPe;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		ElementosPeController.logger.info("[GET - View] : elementospe");
		return "elementospe";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterElementosPe
	 *            ElementosPe Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<ElementosPe> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<ElementosPe> filter(
			@RequestJsonBody(param = "filter") ElementosPe filterElementosPe,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementosPeController.logger.info("[POST - filter] : Obtener ElementosPes");
		return this.elementosPeService.filter(filterElementosPe, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterElementosPe
	 *            ElementosPe Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") ElementosPe filterElementosPe,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementosPeController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples ElementosPes");
		this.elementosPeService.removeMultiple(filterElementosPe, jqGridRequestDto, false);
		ElementosPeController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
